/*
 * Fachlicher Schlüssel für JPA Entität
 */
package de.ivu.elect.business.ergebnis.entity;

import de.ivu.elect.jee.faces.Messages;
import java.util.function.Function;

@javax.enterprise.inject.Vetoed
public class GewaehltTK
implements de.ivu.elect.jee.entity.tk.EntityTK, java.io.Serializable
  {

  private static final long serialVersionUID = 1L;

  private final int hashCode;

    protected final de.ivu.elect.business.ergebnis.entity.GewaehltStatus gewaehltStatus;
    public de.ivu.elect.business.ergebnis.entity.GewaehltStatus getGewaehltStatus(){
      return gewaehltStatus;
    }

  public GewaehltTK(
de.ivu.elect.business.ergebnis.entity.GewaehltStatus gewaehltStatus
  ) {
    super();


      this.gewaehltStatus = gewaehltStatus;
    
hashCode = calculateHashCode();
  }

  @Override
  public int hashCode(){
    return hashCode;
  }


  protected int calculateHashCode() {
        int result = 1;
    
    
                    result = result + ((gewaehltStatus == null) ? 0 : gewaehltStatus.hashCode());
        
            
    return result;
  }

  @Override
  public boolean equals(Object obj) {
    if (this == obj) {
      return true;
    }

    if (obj == null) {
      return false;
    }

    if (hashCode()!=obj.hashCode()) {
      return false;
    }


            
    if (getClass() != obj.getClass()) {
      if (!(obj instanceof GewaehltTK)) {
        return false;
      }

      if (!obj.getClass().isInstance(this)) {
        return obj.equals(this); // equals-Methode aus speziellerer Klasse verwenden
      }

    }

        GewaehltTK other = (GewaehltTK) obj;

                if (gewaehltStatus == null) {
          if (other.gewaehltStatus != null) {
            return false;
          }
        } else if (!gewaehltStatus.equals(other.gewaehltStatus)) {
          return false;
        }
        
            return true;
    
  }

  protected boolean hatAttribute() {
        return true;
      }

  @Override
  public String getEntityMessageKey() {
    return GewaehltConstants.MESSAGE_KEY_ENTITY_EINZAHL;
  }

  @Override
  public java.util.List<de.ivu.elect.jee.entity.tk.EntityFieldValue> getAllEntityFieldValues() {
    java.util.List<de.ivu.elect.jee.entity.tk.EntityFieldValue> result = new java.util.ArrayList<>();

    result.addAll(getEntityFieldValuesForEntity());
    return result;
  }

  @Override
  public java.util.List<de.ivu.elect.jee.entity.tk.EntityFieldValue> getEntityFieldValuesForEntity() {
            java.util.List<de.ivu.elect.jee.entity.tk.EntityFieldValue> result = new java.util.ArrayList<>();

                    result.add(new de.ivu.elect.jee.entity.tk.EntityFieldValue(GewaehltConstants.MESSAGE_KEY_ENTITY_EINZAHL, GewaehltConstants.MESSAGE_KEY_GEWAEHLT_STATUS_EINZAHL, gewaehltStatus));
        
        return result;
      }


            @Override
            public String toString() {
            return "GewaehltTK[" + toStringParameter() + "]";
            }



            protected String toStringParameter() {
            String result = ""

                                        +"gewaehltStatus="+gewaehltStatus
                        
            ;
                            return result;
            
            }

  @Override
  public String toStringLokalisiert(Messages messages) {
    return messages.getMessageForMessageKey(getEntityMessageKey()) + " ["
            + toStringLokalisiertFields(messages)
            + "]"
            ;
   }

            protected String toStringLokalisiertFields(Messages messages) {
        return ""
                                      + messages.getMessageForMessageKey(GewaehltConstants.MESSAGE_KEY_GEWAEHLT_STATUS_EINZAHL) + "=" + gewaehltStatus
                                             ;
      }


            private String toStringLokalisiert(de.ivu.elect.jee.entity.tk.EntityTK entityTK, Messages messages) {
                if (entityTK != null) {
                    return entityTK.toStringLokalisiert(messages);
                }
                return null;
            }

            public static <E extends Gewaehlt> java.util.Map<GewaehltTK, E> mappeGewaehltNachTK(java.util.Collection<E> entities) {
                return entities.stream().collect(java.util.stream.Collectors.toMap(Gewaehlt::getGewaehltTK, Function.<E>identity(), (u,v)-> v));
                }


                public static Function<Gewaehlt, GewaehltTK> getGewaehltToTKFunction() {
                return Gewaehlt::getGewaehltTK;
                }

}
